import java.io.IOException;

/**
 * Abstract class that defines the basic interface that all MEAPsoft
 * composers should follow.
 *
 * @author Ron Weiss (ronw@ee.columbia.edu)
 */
public abstract class Composer extends MEAPUtil
{
    EDLFile outFile;

    /**
     * Setup the Composer - read in files, etc.
     */
    public abstract void setup();

    /**
     *  Compose an EDLFile.  This is where the magic happens.
     */
    public abstract EDLFile compose();

    /*
     * Setup, compose, and write output file
     */
    public void go()
    {
        setup();
        compose();

        try
        {
            outFile.writeFile();
        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
